package net.locusworks.discord.eighttrack.events.main.handlers;

import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import net.dv8tion.jda.api.events.message.guild.GuildMessageReceivedEvent;
import net.locusworks.discord.eighttrack.events.main.AbstractMainEventHandler;
import net.locusworks.discord.eighttrack.handlers.GuildMusicHandler;
import net.locusworks.discord.eighttrack.services.RepositoryService;
import net.locusworks.logger.ApplicationLogger;
import net.locusworks.logger.ApplicationLoggerFactory;

@Component
public class RepeatSongHandler extends AbstractMainEventHandler {

  private ApplicationLogger logger;
  
  @Autowired
  private RepositoryService guildRepoService;
  
  public RepeatSongHandler() {
    super("-repeat");
    logger = ApplicationLoggerFactory.getLogger(RepeatSongHandler.class);
  }

  @Override
  public void executeEvent(GuildMusicHandler musicHandler, GuildMessageReceivedEvent event, List<String> commands) {
    try {
      musicHandler.repeat(event);
      musicHandler.isPlaying(true);
    } catch (Exception ex) {
      logger.error("Unable to repeat songs: " + ex.getMessage(), ex);
      guildRepoService.logEntry(event.getGuild().getIdLong(), ex, "Unable to repeat song: %s", ex.getMessage());
      sendMessage(event, "Sorry I am unable to repeat songs: " + ex.getMessage());
    }
  }
  
  @Override
  public String help() {
    return "-repeat (repeats the current song list)";
  }

}
